<?php

/*
 * Adds Mascot_Core_Insolan_Widget_InstagramFeed widget.
 */
if( !class_exists( 'Mascot_Core_Insolan_Widget_InstagramFeed' ) ) {
class Mascot_Core_Insolan_Widget_InstagramFeed extends Mascot_Core_Insolan_Widget_Loader {

	/**
	 * Register widget with WordPress.
	 */
	function __construct() {
		$this->widgetOptions = array( 
			'classname'		=> 'widget-instagram-feed clearfix',
			'description'	=> esc_html__( 'The widget lets you easily displays instagram feed as list or carousel.', 'mascot-core-insolan-wp' ),
		);
		parent::__construct( 'tm_widget_instagram_feed', esc_html__( '(TM) Instagram Feed', 'mascot-core-insolan-wp' ), $this->widgetOptions );
		$this->getFormFields();
	}

	
	/**
	 * Get form fields of the widget.
	 */
	protected function getFormFields() {
		$this->formFields = array(
			array(
				'id'		=> 'title',
				'type'		=> 'text',
				'title'		=> esc_html__( 'Widget Title:', 'mascot-core-insolan-wp' ),
				'desc'		=> '',
				'default'	=> esc_html__( 'Instagram Feed', 'mascot-core-insolan-wp' ),
			),
			array(
				'id'		=> 'custom_css_class',
				'type'		=> 'text',
				'title'		=> esc_html__( 'Custom CSS Class:', 'mascot-core-insolan-wp' ),
				'desc'		=> esc_html__( 'To style particular content element', 'mascot-core-insolan-wp' ),
			),
			array(
				'id'		=> 'userid',
				'type'		=> 'text',
				'title'		=> esc_html__( 'Instagram User ID:', 'mascot-core-insolan-wp' ),
				'desc'		=> sprintf( esc_html__( 'Put your instagram UserId here. Collect your own UserId from %1$shere%2$s.', 'mascot-core-insolan-wp' ), '<a target="_blank" href="' . esc_url( 'https://smashballoon.com/instagram-feed/find-instagram-user-id/' ) . '">', '</a>' ),
				'default'	=> '3450544574',
			),
			array(
				'id'		=> 'accesstoken',
				'type'		=> 'text',
				'title'		=> esc_html__( 'Instagram Access Token:', 'mascot-core-insolan-wp' ),
				'desc'		=> sprintf( esc_html__( 'Put your instagram Access Token here. Collect Your own Instagram Access Token from %1$shere%2$s.', 'mascot-core-insolan-wp' ), '<a target="_blank" href="' . esc_url( 'http://instagram.pixelunion.net/' ) . '">', '</a>' ),
				'default'	=> '3450544574.1677ed0.7d0725a565914415b40a4953c17bcdc9',
			),
			array(
				'id'		=> 'count',
				'type'		=> 'text',
				'title'		=> esc_html__( 'Number of Images to Show:', 'mascot-core-insolan-wp' ),
				'desc'		=> '',
			),
			array(
				'id'		=> 'feed_type',
				'type'		=> 'dropdown',
				'title'		=> esc_html__( 'Feed Type:', 'mascot-core-insolan-wp' ),
				'desc'		=> '',
				'options'	=> array(
					'grid'		=> esc_html__( 'Grid', 'mascot-core-insolan-wp' ),
					'carousel'   => esc_html__( 'Carousel', 'mascot-core-insolan-wp' ),
				)
			),
			array(
				'id'		=> 'feed_columns',
				'type'		=> 'dropdown',
				'title'		=> esc_html__( 'Columns:', 'mascot-core-insolan-wp' ),
				'desc'		=> '',
				'options'	=> array(
					'feed-grid-3'		=> esc_html__( '3', 'mascot-core-insolan-wp' ),
					'feed-grid-4'   => esc_html__( '4', 'mascot-core-insolan-wp' ),
				)
			),
			array(
				'id'		=> 'image_resolution',
				'type'		=> 'dropdown',
				'title'		=> esc_html__( 'Image Resolution:', 'mascot-core-insolan-wp' ),
				'desc'		=> '',
				'options'	=> array(
					'thumbnail' => esc_html__( 'Thumbnail (150x150)', 'mascot-core-insolan-wp' ),
					'low_resolution' => esc_html__( 'Low Resolution (320x320)', 'mascot-core-insolan-wp' ),
					'standard_resolution' => esc_html__( 'Standard Resolution (640x640)', 'mascot-core-insolan-wp' ),
				)
			),
		);
	}



	/**
	 * Front-end display of widget.
	 *
	 * @see WP_Widget::widget()
	 *
	 * @param array $args	 Widget arguments.
	 * @param array $instance Saved values from database.
	 */
	public function widget( $args, $instance ) {
		echo wp_kses_post($args['before_widget']);

		if ( ! empty( $instance['title'] ) ) {
			echo wp_kses_post( $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ) . $args['after_title'] );
		}

		wp_register_script( 'instafeed', MASCOT_CORE_TEMPLATE_URI . '/assets/js/plugins/instafeed.min.js', array('jquery'), false, true );
		wp_enqueue_script( 'instafeed' );
		//Produce HTML version by using the parameters (filename, variation, folder name, parameters, widget_ob_start)
		$html = mascot_core_insolan_get_widget_template_part( 'instagram-feed' . '-' . $instance['feed_type'], null, 'instagram-feed/tpl', $instance, false );

		echo wp_kses_post($args['after_widget']);
	}
}
}